Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HistogramView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HistogramView.cs	(revision 10817)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HistogramView.cs	(revision 10818)
@@ -16,5 +16,4 @@
       chartType = DataRowVisualProperties.DataRowChartType.Histogram;
       chartTitle = HISTOGRAM_CHART_TITLE;
-      allInOneMode = false;
     }
 
@@ -25,9 +24,18 @@
 
     private void allInOneCheckBox_CheckedChanged(object sender, EventArgs e) {
-      if (allInOneMode == false)
-        allInOneMode = true;
+      if (allInOneCheckBox.Checked)
+        Content.AllInOneMode = true;
       else
-        allInOneMode = false;
+        Content.AllInOneMode = false;
       GenerateChart();
+    }
+
+    protected override void OnContentChanged()
+    {
+      base.OnContentChanged();
+      if (Content != null)
+      {
+        allInOneCheckBox.Checked = Content.AllInOneMode;
+      }
     }
 
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/LineChartView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/LineChartView.cs	(revision 10817)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/LineChartView.cs	(revision 10818)
@@ -45,9 +45,18 @@
 
     private void allInOneCheckBox_CheckedChanged(object sender, EventArgs e) {
-      if (allInOneMode == false)
-        allInOneMode = true;
+      if (allInOneCheckBox.Checked)
+        Content.AllInOneMode = true;
       else
-        allInOneMode = false;
+        Content.AllInOneMode = false;
       GenerateChart();
+    }
+
+    protected override void OnContentChanged()
+    {
+      base.OnContentChanged();
+      if (Content != null)
+      {
+        allInOneCheckBox.Checked = Content.AllInOneMode;
+      }
     }
   }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingChartView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingChartView.cs	(revision 10817)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingChartView.cs	(revision 10818)
@@ -41,10 +41,8 @@
     private PreprocessingDataTable dataTable;
     private List<PreprocessingDataTable> dataTablePerVariable;
-    private ICheckedItemList<StringValue> variableItemList;
     private List<DataRow> dataRows;
 
     protected DataRowVisualProperties.DataRowChartType chartType;
     protected string chartTitle;
-    protected bool allInOneMode;
 
     private const string DEFAULT_CHART_TITLE = "Chart";
@@ -55,5 +53,4 @@
       chartType = DataRowVisualProperties.DataRowChartType.Line;
       chartTitle = DEFAULT_CHART_TITLE;
-      allInOneMode = true;
     }
 
@@ -73,5 +70,6 @@
       }
 
-      if (!allInOneMode)
+      //if (!Content.AllInOneMode)
+        if (Content != null && !Content.AllInOneMode)
         GenerateChart();
 
@@ -104,6 +102,9 @@
 
     private void InitData() {
-      variableItemList = logic.CreateVariableItemList();
-      checkedItemList.Content = variableItemList;
+      if (Content.VariableItemList == null)
+      {
+        Content.VariableItemList = logic.CreateVariableItemList();
+      }
+      checkedItemList.Content = Content.VariableItemList;
       dataRows = logic.CreateAllDataRows(chartType);
 
@@ -115,6 +116,7 @@
       // init data table per variable
       dataTablePerVariable = new List<PreprocessingDataTable>();
-      foreach (var checkedItem in variableItemList.CheckedItems) {
-        string variableName = variableItemList[checkedItem.Index].Value;
+      foreach (var checkedItem in Content.VariableItemList.CheckedItems)
+      {
+        string variableName = Content.VariableItemList[checkedItem.Index].Value;
         PreprocessingDataTable d = new PreprocessingDataTable(variableName);
         DataRow row = GetDataRow(variableName);
@@ -144,5 +146,5 @@
         logic = Content.ChartLogic;
         InitData();
-        variableItemList.CheckedItemsChanged += CheckedItemsChanged;
+        Content.VariableItemList.CheckedItemsChanged += CheckedItemsChanged;
         GenerateChart();
       }
@@ -190,6 +192,6 @@
       d.Rows.Add(row);
       dataTablePerVariable.Add(d);
-      variableItemList.Add(new StringValue(name));
-      if (!allInOneMode)
+      Content.VariableItemList.Add(new StringValue(name));
+      if (!Content.AllInOneMode)
         GenerateChart();
     }
@@ -202,11 +204,12 @@
       StringValue stringValue = FindVariableItemList(name);
       if (stringValue != null)
-        variableItemList.Remove(stringValue);
-      if (!allInOneMode)
+        Content.VariableItemList.Remove(stringValue);
+      if (!Content.AllInOneMode)
         GenerateChart();
     }
 
     private StringValue FindVariableItemList(string name) {
-      foreach (StringValue stringValue in variableItemList) {
+      foreach (StringValue stringValue in Content.VariableItemList)
+      {
         if (stringValue.Value == name)
           return stringValue;
@@ -219,5 +222,6 @@
       ClearTableLayout();
 
-      if (allInOneMode) {
+      if (Content.AllInOneMode)
+      {
         GenerateSingleChartLayout();
       } else
@@ -247,5 +251,5 @@
     private void GenerateMultiChartLayout() {
       int checkedItemsCnt = 0;
-      foreach (var item in variableItemList.CheckedItems)
+      foreach (var item in Content.VariableItemList.CheckedItems)
         checkedItemsCnt++;
 
@@ -320,8 +324,8 @@
 
     private void radioButton1_CheckedChanged(object sender, EventArgs e) {
-      if (allInOneMode == false)
-        allInOneMode = true;
+      if (Content.AllInOneMode == false)
+        Content.AllInOneMode = true;
       else
-        allInOneMode = false;
+        Content.AllInOneMode = false;
       GenerateChart();
     }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingChartContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingChartContent.cs	(revision 10817)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingChartContent.cs	(revision 10818)
@@ -23,8 +23,16 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using System;
+using System.Collections.Generic;
 
 namespace HeuristicLab.DataPreprocessing {
   [Item("PreprocessingChart", "Represents a preprocessing chart.")]
   public class PreprocessingChartContent : Item, IViewShortcut {
+
+    private bool allInOneMode = true;
+
+    private ICheckedItemList<StringValue> variableItemList = null;
+
 
     private readonly IChartLogic chartLogic;
@@ -55,4 +63,16 @@
       remove { chartLogic.Changed -= value; }
     }
+
+    public bool AllInOneMode
+    {
+      get { return this.allInOneMode; }
+      set { this.allInOneMode = value; }
+    }
+
+    public ICheckedItemList<StringValue> VariableItemList
+    {
+      get { return this.variableItemList; }
+      set { this.variableItemList = value; }
+    }
   }
 }