Index: /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/HeuristicLab.Problems.DataAnalysis.Transformations-3.3.csproj
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/HeuristicLab.Problems.DataAnalysis.Transformations-3.3.csproj	(revision 10840)
+++ /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/HeuristicLab.Problems.DataAnalysis.Transformations-3.3.csproj	(revision 10841)
@@ -48,10 +48,10 @@
   <ItemGroup>
     <Compile Include="CopyColumnTransformation.cs" />
-    <Compile Include="StandardDeviationTransformation.cs" />
+    <Compile Include="ShiftStandardDistributionTransformation.cs" />
     <Compile Include="PowerTransformation.cs" />
     <Compile Include="ExponentialTransformation.cs" />
     <Compile Include="LogarithmicTransformation.cs" />
     <Compile Include="ReciprocalTransformation.cs" />
-    <Compile Include="ShiftDataToRangeTransformation.cs" />
+    <Compile Include="ShiftToRangeTransformation.cs" />
     <Compile Include="Transformation.cs" />
     <None Include="HeuristicLab.snk" />
Index: anches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftDataToRangeTransformation.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftDataToRangeTransformation.cs	(revision 10840)
+++ 	(revision )
@@ -1,63 +1,0 @@
-﻿using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Problems.DataAnalysis.Transformations {
-  [Item("ShiftDataToRangeTransformation", "f(x) = k * x + d, start <= f(x) <= end | Represents a linear Transformation using Parameters defining a target range")]
-  public class ShiftDataToRangeTransformation : LinearTransformation {
-    protected const string RangeParameterName = "Range";
-
-    #region Parameters
-    public IValueParameter<DoubleRange> RangeParameter {
-      get { return (IValueParameter<DoubleRange>)Parameters[RangeParameterName]; }
-    }
-    #endregion
-
-    #region properties
-    public DoubleRange Range {
-      get { return RangeParameter.Value; }
-    }
-    #endregion
-
-    [StorableConstructor]
-    protected ShiftDataToRangeTransformation(bool deserializing) : base(deserializing) { }
-    protected ShiftDataToRangeTransformation(Transformation<double> original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public ShiftDataToRangeTransformation(IEnumerable<string> allowedColumns)
-      : base(allowedColumns) {
-      MultiplierParameter.Hidden = true;
-      AddendParameter.Hidden = true;
-      Parameters.Add(new ValueParameter<DoubleRange>(RangeParameterName, "start, end | Range for the target window of the linear transformation", new DoubleRange(0.0, 1.0)));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new ShiftDataToRangeTransformation(this, cloner);
-    }
-
-    public override IEnumerable<double> Apply(IEnumerable<double> data) {
-      ConfigureParameters(data);
-      return base.Apply(data);
-    }
-
-    public override bool Check(IEnumerable<double> data, out string errorMsg) {
-      ConfigureParameters(data);
-      return base.Check(data, out errorMsg);
-    }
-
-    protected void ConfigureParameters(IEnumerable<double> data) {
-      double originalRangeStart = data.Min();
-      double originalRangeEnd = data.Max();
-
-      double originalRangeWidth = originalRangeEnd - originalRangeStart;
-      double targetRangeWidth = Range.End - Range.Start;
-
-      Multiplier = targetRangeWidth / originalRangeWidth;
-      Addend = Range.Start - originalRangeStart * Multiplier;
-    }
-  }
-}
Index: /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftStandardDistributionTransformation.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftStandardDistributionTransformation.cs	(revision 10841)
+++ /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftStandardDistributionTransformation.cs	(revision 10841)
@@ -0,0 +1,101 @@
+﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.DataAnalysis.Transformations {
+  [Item("ShiftStandardDistributionTransformation.cs", "f(x) = ((x - m_org) / s_org ) * s_tar + m_tar | Represents Transformation to unit standard deviation and additional linear transformation to a target Mean and Standard deviation")]
+  public class ShiftStandardDistributionTransformation : Transformation<double> {
+    protected const string OriginalMeanParameterName = "OriginalMean";
+    protected const string OriginalStandardDeviationParameterName = "OriginalStandardDeviation";
+    protected const string MeanParameterName = "Mean";
+    protected const string StandardDeviationParameterName = "StandardDeviation";
+
+    #region Parameters
+    public IValueParameter<DoubleValue> OriginalMeanParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[OriginalMeanParameterName]; }
+    }
+    public IValueParameter<DoubleValue> OriginalStandardDeviationParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[OriginalStandardDeviationParameterName]; }
+    }
+    public IValueParameter<DoubleValue> MeanParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[MeanParameterName]; }
+    }
+    public IValueParameter<DoubleValue> StandardDeviationParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters[StandardDeviationParameterName]; }
+    }
+    #endregion
+
+    #region properties
+    public double OriginalMean {
+      get { return OriginalMeanParameter.Value.Value; }
+      set { OriginalMeanParameter.Value.Value = value; }
+    }
+    public double OriginalStandardDeviation {
+      get { return OriginalStandardDeviationParameter.Value.Value; }
+      set { OriginalStandardDeviationParameter.Value.Value = value; }
+    }
+    public double Mean {
+      get { return MeanParameter.Value.Value; }
+    }
+    public double StandardDeviation {
+      get { return StandardDeviationParameter.Value.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected ShiftStandardDistributionTransformation(bool deserializing) : base(deserializing) { }
+    protected ShiftStandardDistributionTransformation(Transformation<double> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public ShiftStandardDistributionTransformation(IEnumerable<string> allowedColumns)
+      : base(allowedColumns) {
+      Parameters.Add(new ValueParameter<DoubleValue>(OriginalMeanParameterName, "m_org | Mean value of the original data's deviation.", new DoubleValue()));
+      Parameters.Add(new ValueParameter<DoubleValue>(OriginalStandardDeviationParameterName, "s_org | Standard deviation of the original data.", new DoubleValue()));
+      OriginalMeanParameter.Hidden = true;
+      OriginalStandardDeviationParameter.Hidden = true;
+      Parameters.Add(new ValueParameter<DoubleValue>(MeanParameterName, "m_tar | Mean value for the target deviation.", new DoubleValue(0.0)));
+      Parameters.Add(new ValueParameter<DoubleValue>(StandardDeviationParameterName, "s_tar | Standard deviation for the target data.", new DoubleValue(1.0)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ShiftStandardDistributionTransformation(this, cloner);
+    }
+
+    // http://en.wikipedia.org/wiki/Standard_deviation
+    // http://www.statistics4u.info/fundstat_germ/ee_ztransform.html
+    // https://www.uni-due.de/~bm0061/vorl12.pdf p5
+    public override IEnumerable<double> Apply(IEnumerable<double> data) {
+      ConfigureParameters(data);
+      if (OriginalStandardDeviation == 0.0) {
+        foreach (var e in data) {
+          yield return e;
+        }
+        yield break;
+      }
+
+      foreach (var e in data) {
+        double unitNormalDistributedValue = (e - OriginalMean) / OriginalStandardDeviation;
+        yield return unitNormalDistributedValue * StandardDeviation + Mean;
+      }
+    }
+
+    public override bool Check(IEnumerable<double> data, out string errorMsg) {
+      ConfigureParameters(data);
+      errorMsg = "";
+      if (OriginalStandardDeviation == 0.0) {
+        errorMsg = "Standard deviaton for the original data is 0.0, Transformation cannot be applied onto these values.";
+        return false;
+      }
+      return true;
+    }
+
+    protected void ConfigureParameters(IEnumerable<double> data) {
+      OriginalStandardDeviation = data.StandardDeviation();
+      OriginalMean = data.Average();
+    }
+  }
+}
Index: /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftToRangeTransformation.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftToRangeTransformation.cs	(revision 10841)
+++ /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/ShiftToRangeTransformation.cs	(revision 10841)
@@ -0,0 +1,63 @@
+﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.DataAnalysis.Transformations {
+  [Item("ShiftToRangeTransformation", "f(x) = k * x + d, start <= f(x) <= end | Represents a linear Transformation using Parameters defining a target range")]
+  public class ShiftToRangeTransformation : LinearTransformation {
+    protected const string RangeParameterName = "Range";
+
+    #region Parameters
+    public IValueParameter<DoubleRange> RangeParameter {
+      get { return (IValueParameter<DoubleRange>)Parameters[RangeParameterName]; }
+    }
+    #endregion
+
+    #region properties
+    public DoubleRange Range {
+      get { return RangeParameter.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected ShiftToRangeTransformation(bool deserializing) : base(deserializing) { }
+    protected ShiftToRangeTransformation(Transformation<double> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public ShiftToRangeTransformation(IEnumerable<string> allowedColumns)
+      : base(allowedColumns) {
+      MultiplierParameter.Hidden = true;
+      AddendParameter.Hidden = true;
+      Parameters.Add(new ValueParameter<DoubleRange>(RangeParameterName, "start, end | Range for the target window of the linear transformation", new DoubleRange(0.0, 1.0)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ShiftToRangeTransformation(this, cloner);
+    }
+
+    public override IEnumerable<double> Apply(IEnumerable<double> data) {
+      ConfigureParameters(data);
+      return base.Apply(data);
+    }
+
+    public override bool Check(IEnumerable<double> data, out string errorMsg) {
+      ConfigureParameters(data);
+      return base.Check(data, out errorMsg);
+    }
+
+    protected void ConfigureParameters(IEnumerable<double> data) {
+      double originalRangeStart = data.Min();
+      double originalRangeEnd = data.Max();
+
+      double originalRangeWidth = originalRangeEnd - originalRangeStart;
+      double targetRangeWidth = Range.End - Range.Start;
+
+      Multiplier = targetRangeWidth / originalRangeWidth;
+      Addend = Range.Start - originalRangeStart * Multiplier;
+    }
+  }
+}
Index: anches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/StandardDeviationTransformation.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/StandardDeviationTransformation.cs	(revision 10840)
+++ 	(revision )
@@ -1,101 +1,0 @@
-﻿using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Problems.DataAnalysis.Transformations {
-  [Item("StandardDeviationTransformation", "f(x) = ((x - m_org) / s_org ) * s_tar + m_tar | Represents Transformation to unit standard deviation and additional linear transformation to a target Mean and Standard deviation")]
-  public class StandardDeviationTransformation : Transformation<double> {
-    protected const string OriginalMeanParameterName = "OriginalMean";
-    protected const string OriginalStandardDeviationParameterName = "OriginalStandardDeviation";
-    protected const string MeanParameterName = "Mean";
-    protected const string StandardDeviationParameterName = "StandardDeviation";
-
-    #region Parameters
-    public IValueParameter<DoubleValue> OriginalMeanParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters[OriginalMeanParameterName]; }
-    }
-    public IValueParameter<DoubleValue> OriginalStandardDeviationParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters[OriginalStandardDeviationParameterName]; }
-    }
-    public IValueParameter<DoubleValue> MeanParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters[MeanParameterName]; }
-    }
-    public IValueParameter<DoubleValue> StandardDeviationParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters[StandardDeviationParameterName]; }
-    }
-    #endregion
-
-    #region properties
-    public double OriginalMean {
-      get { return OriginalMeanParameter.Value.Value; }
-      set { OriginalMeanParameter.Value.Value = value; }
-    }
-    public double OriginalStandardDeviation {
-      get { return OriginalStandardDeviationParameter.Value.Value; }
-      set { OriginalStandardDeviationParameter.Value.Value = value; }
-    }
-    public double Mean {
-      get { return MeanParameter.Value.Value; }
-    }
-    public double StandardDeviation {
-      get { return StandardDeviationParameter.Value.Value; }
-    }
-    #endregion
-
-    [StorableConstructor]
-    protected StandardDeviationTransformation(bool deserializing) : base(deserializing) { }
-    protected StandardDeviationTransformation(Transformation<double> original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public StandardDeviationTransformation(IEnumerable<string> allowedColumns)
-      : base(allowedColumns) {
-      Parameters.Add(new ValueParameter<DoubleValue>(OriginalMeanParameterName, "m_org | Mean value of the original data's deviation.", new DoubleValue()));
-      Parameters.Add(new ValueParameter<DoubleValue>(OriginalStandardDeviationParameterName, "s_org | Standard deviation of the original data.", new DoubleValue()));
-      OriginalMeanParameter.Hidden = true;
-      OriginalStandardDeviationParameter.Hidden = true;
-      Parameters.Add(new ValueParameter<DoubleValue>(MeanParameterName, "m_tar | Mean value for the target deviation.", new DoubleValue(0.0)));
-      Parameters.Add(new ValueParameter<DoubleValue>(StandardDeviationParameterName, "s_tar | Standard deviation for the target data.", new DoubleValue(1.0)));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new StandardDeviationTransformation(this, cloner);
-    }
-
-    // http://en.wikipedia.org/wiki/Standard_deviation
-    // http://www.statistics4u.info/fundstat_germ/ee_ztransform.html
-    // https://www.uni-due.de/~bm0061/vorl12.pdf p5
-    public override IEnumerable<double> Apply(IEnumerable<double> data) {
-      ConfigureParameters(data);
-      if (OriginalStandardDeviation == 0.0) {
-        foreach (var e in data) {
-          yield return e;
-        }
-        yield break;
-      }
-
-      foreach (var e in data) {
-        double unitNormalDistributedValue = (e - OriginalMean) / OriginalStandardDeviation;
-        yield return unitNormalDistributedValue * StandardDeviation + Mean;
-      }
-    }
-
-    public override bool Check(IEnumerable<double> data, out string errorMsg) {
-      ConfigureParameters(data);
-      errorMsg = "";
-      if (OriginalStandardDeviation == 0.0) {
-        errorMsg = "Standard deviaton for the original data is 0.0, Transformation cannot be applied onto these values.";
-        return false;
-      }
-      return true;
-    }
-
-    protected void ConfigureParameters(IEnumerable<double> data) {
-      OriginalStandardDeviation = data.StandardDeviation();
-      OriginalMean = data.Average();
-    }
-  }
-}